<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:a="http://xmlns.jcp.org/jsf/passthrough"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:p="http://primefaces.org/ui">
    <h:body>   
        <div class="container">
            <h2>#{msgs.salesByAuthor}</h2>

            <h:form id="authorsForm" class="form-inline">
                <p:growl id="growl" showDetail="true"/>
                <p:message for="toDate"/>
                <div class="form-group mb-2">
                    <h:outputLabel for="fromDate" class="sr-only" value="from"/> 
                    <h:inputText class="form-control" id="fromDate" value="#{reportBackingBean.fromDate}" a:type="date">  
                    </h:inputText>
                </div>
                <div class="form-group mx-sm-3 mb-2">
                    <h:outputLabel for="toDate" class="sr-only" value="to"/> 
                    <h:inputText class="form-control" id="toDate" value="#{reportBackingBean.toDate}" a:type="date"
                                 validator="#{reportBackingBean.validateDateRange}">  
                    </h:inputText>

                </div>
                <div class="form-group mx-sm-3 mb-2">
                    <h:selectOneMenu id="select" class="form-control" value="#{reportBackingBean.name}" 
                                     required="true" requiredMessage="#{msgs.author} #{msgs.is} #{msgs.required}">
                        <f:selectItem itemLabel="--- #{msgs.selectAuthor} ---"/>
                        <f:selectItems value="#{authorsJpaController.findAuthorsEntities()}" var="author" itemLabel="#{author.name}" itemValue="#{author.name}" />
                    </h:selectOneMenu>
                    <p:message for="select"/>
                </div>
                <p:commandButton update=":authorsForm:datatable authorsForm" value="#{msgs.search}" styleClass="btn btn-primary mb-2" />

                <h:panelGroup id="datatable">
                    <p:dataTable value="#{reportBackingBean.authorSale}" 
                                 var="author"
                                 paginator="true"
                                 paginatorTemplate="{CurrentPageReport} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {RowsPerPageDropdown}"
                                 currentPageReportTemplate="{startRecord}-{endRecord} of {totalRecords} records">
                        <p:column >
                            <f:facet name="header">#{msgs.author}</f:facet>
                                #{author.authorName} 
                        </p:column>
                        <p:column >
                            <f:facet name="header">#{msgs.title}</f:facet>
                                #{author.bookTitle} 
                        </p:column>
                        <p:column>
                            <f:facet name="header">#{msgs.price}</f:facet>
                            #{author.bookPrice} $
                        </p:column>
                        <p:column>
                            <f:facet name="header">#{msgs.datePurchased}</f:facet>
                                #{author.datePurchased}
                        </p:column>
                        <p:columnGroup type="footer">
                            <p:row>
                                <p:column colspan="2" style="text-align:right" footerText="Total:" />
                                <p:column footerText="#{reportBackingBean.authorSale.stream().map(as->as.bookPrice).sum()} $" />
                                <p:column footerText=""/>
                            </p:row>
                        </p:columnGroup>
                    </p:dataTable>
                </h:panelGroup>
            </h:form>
        </div>
    </h:body>
</html>

